﻿@page "/"
@attribute [Authorize]

<div class="row">
    <div class="col-lg-6">
        <TimeReport ReportType="ReportType.Month"></TimeReport>
    </div>
    <div class="col-lg-6">
        <TimeReport ReportType="ReportType.Week"></TimeReport>
    </div>
</div>
<SfSpinner @bind-Visible="IsLoading" Label="Fetching data..." />
<SfToast Title="Travel logging"
         Timeout="5000"
         ShowCloseButton="true"
         ShowProgressBar="true"
         @ref="@objToast">
    <ToastPosition X="Right" Y="Bottom"></ToastPosition>
</SfToast>
<div class="row">
    <div class="col-lg-6">
        @if (WeeksOfYear != null)
        {
            <br />
            <b>Weekly travel log</b>
            <br />
            <br />
            <div class="d-flex flex-row">
                <SfButton CssClass="flex-grow-0" @onclick="onPreviousWeekClick" Content="< Previous"></SfButton>
                &nbsp;
                <SfDropDownList @ref="WeekDdl"
                                DataSource="@WeeksOfYear"
                                CssClass="flex-grow-1"
                                TItem="DropdownValue"
                                TValue="string">
                    <DropDownListFieldSettings Value="WeekDays" />
                    <DropDownListEvents TItem="DropdownValue"
                                        TValue="string"
                                        ValueChange="@ValueChangedHandler" />
                </SfDropDownList>
                &nbsp;
                <SfButton CssClass="flex-grow-0" @onclick="onNextWeekClick" Content="Next >"></SfButton>
            </div>
            <br />
            <SfGrid DataSource="@SelectedTravels"
                    @ref="TravelLogGrid"
                    ID="TravelLogGrid"
                    ShowColumnChooser="true"
                    AllowExcelExport="true"
                    Toolbar="@(new List<string> { "ColumnChooser", "ExcelExport" })">
                <GridAggregates>
                    <GridAggregate>
                        <GridAggregateColumns>
                            <GridAggregateColumn Field=@nameof(TravelResponse.TravelDistance) Type="AggregateType.Custom" Format="C2">
                                <FooterTemplate>
                                    @{
                                        <b>@GetTotalDistance() km</b>
                                    }
                                </FooterTemplate>
                            </GridAggregateColumn>
                            <GridAggregateColumn Field=@nameof(TravelResponse.TravelMinutes) Type="AggregateType.Custom" Format="C2">
                                <FooterTemplate>
                                    @{
                                        <b>@GetTotalTripTime()</b>
                                    }
                                </FooterTemplate>
                            </GridAggregateColumn>
                            <GridAggregateColumn Field=@nameof(TravelResponse.TravelConsumption) Type="AggregateType.Custom" Format="C2">
                                <FooterTemplate>
                                    @{
                                        <b>@GetAverageConsumption() kWh/100km</b>
                                    }
                                </FooterTemplate>
                            </GridAggregateColumn>
                            <GridAggregateColumn Field=@nameof(TravelResponse.TravelTemperature) Type="AggregateType.Custom" Format="C2">
                                <FooterTemplate>
                                    @{
                                        <b>@GetAverageTemperature() °C</b>
                                    }
                                </FooterTemplate>
                            </GridAggregateColumn>
                            <GridAggregateColumn Field=@nameof(TravelResponse.TravelAverageSpeed) Type="AggregateType.Custom" Format="C2">
                                <FooterTemplate>
                                    @{
                                        <b>@GetAverageSpeed() km/h</b>
                                    }
                                </FooterTemplate>
                            </GridAggregateColumn>
                            <GridAggregateColumn Field=@nameof(TravelResponse.TravelEnergyConsumed) Type="AggregateType.Custom" Format="C2">
                                <FooterTemplate>
                                    @{
                                        <b>@GetTotalEnergyConsumed() kWh</b>
                                    }
                                </FooterTemplate>
                            </GridAggregateColumn>
                        </GridAggregateColumns>
                    </GridAggregate>
                </GridAggregates>
                <GridEvents OnToolbarClick="ToolbarClickHandler" TValue="TravelResponse" />

                <GridColumns>
                    <GridColumn Field=@nameof(TravelResponse.Id) ShowInColumnChooser="false" Visible="false" IsPrimaryKey="true"></GridColumn>
                    <GridColumn Field=@nameof(TravelResponse.TravelDate) Format="dd.MM.yyyy" HeaderText="Date"></GridColumn>
                    <GridColumn Field=@nameof(TravelResponse.TravelDistance) HeaderText="Distance"></GridColumn>
                    <GridColumn Field=@nameof(TravelResponse.TravelConsumption) HeaderText="Consumption"></GridColumn>
                    <GridColumn Field=@nameof(TravelResponse.TravelMinutes) HeaderText="Elapsed minutes"></GridColumn>
                    <GridColumn Visible="false" Field=@nameof(TravelResponse.TravelTemperature) HeaderText="Temperature"></GridColumn>
                    <GridColumn Visible="false" Field=@nameof(TravelResponse.TravelAverageSpeed) HeaderText="Avg. Speed"></GridColumn>
                    <GridColumn Visible="false" Field=@nameof(TravelResponse.TravelEnergyConsumed) HeaderText="kWh Consumed"></GridColumn>
                </GridColumns>
            </SfGrid>
        }
    </div>
</div>